/* ***********************************************************
 * This file was automatically generated on 2020-01-22.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

/**
 * Measures Particulate Matter concentration (PM1.0, PM2.5 and PM10)
 */
public class BrickletParticulateMatter extends Device {
	public final static int DEVICE_IDENTIFIER = 2110;
	public final static String DEVICE_DISPLAY_NAME = "Particulate Matter Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletparticulatematter", DEVICE_IDENTIFIER, BrickletParticulateMatter.class, BrickletParticulateMatterActions.class, "2.0.2");

	public final static byte FUNCTION_GET_PM_CONCENTRATION = (byte)1;
	public final static byte FUNCTION_GET_PM_COUNT = (byte)2;
	public final static byte FUNCTION_SET_ENABLE = (byte)3;
	public final static byte FUNCTION_GET_ENABLE = (byte)4;
	public final static byte FUNCTION_GET_SENSOR_INFO = (byte)5;
	public final static byte FUNCTION_SET_PM_CONCENTRATION_CALLBACK_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_PM_CONCENTRATION_CALLBACK_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_SET_PM_COUNT_CALLBACK_CONFIGURATION = (byte)8;
	public final static byte FUNCTION_GET_PM_COUNT_CALLBACK_CONFIGURATION = (byte)9;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_PM_CONCENTRATION = 10;
	private final static int CALLBACK_PM_COUNT = 11;

	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<PMConcentrationListener> listenerPMConcentration = new CopyOnWriteArrayList<PMConcentrationListener>();
	private List<PMCountListener> listenerPMCount = new CopyOnWriteArrayList<PMCountListener>();

	public class PMConcentration {
		public int pm10;
		public int pm25;
		public int pm100;

		public String toString() {
			return "[" + "pm10 = " + pm10 + ", " + "pm25 = " + pm25 + ", " + "pm100 = " + pm100 + "]";
		}
	}

	public class PMCount {
		public int greater03um;
		public int greater05um;
		public int greater10um;
		public int greater25um;
		public int greater50um;
		public int greater100um;

		public String toString() {
			return "[" + "greater03um = " + greater03um + ", " + "greater05um = " + greater05um + ", " + "greater10um = " + greater10um + ", " + "greater25um = " + greater25um + ", " + "greater50um = " + greater50um + ", " + "greater100um = " + greater100um + "]";
		}
	}

	public class SensorInfo {
		public int sensorVersion;
		public int lastErrorCode;
		public int framingErrorCount;
		public int checksumErrorCount;

		public String toString() {
			return "[" + "sensorVersion = " + sensorVersion + ", " + "lastErrorCode = " + lastErrorCode + ", " + "framingErrorCount = " + framingErrorCount + ", " + "checksumErrorCount = " + checksumErrorCount + "]";
		}
	}

	public class PMConcentrationCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class PMCountCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletParticulateMatter#setPMConcentrationCallbackConfiguration(long, boolean)}.
	 * 
	 * The parameters are the same as {@link BrickletParticulateMatter#getPMConcentration()}.
	 */
	public interface PMConcentrationListener extends DeviceListener {
		public void pmConcentration(int pm10, int pm25, int pm100);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletParticulateMatter#setPMCountCallbackConfiguration(long, boolean)}.
	 * 
	 * The parameters are the same as {@link BrickletParticulateMatter#getPMCount()}.
	 */
	public interface PMCountListener extends DeviceListener {
		public void pmCount(int greater03um, int greater05um, int greater10um, int greater25um, int greater50um, int greater100um);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletParticulateMatter(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_PM_CONCENTRATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_PM_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_ENABLE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ENABLE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SENSOR_INFO)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_PM_CONCENTRATION_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_PM_CONCENTRATION_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_PM_COUNT_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_PM_COUNT_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_PM_CONCENTRATION] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int pm10 = IPConnection.unsignedShort(bb.getShort());
				int pm25 = IPConnection.unsignedShort(bb.getShort());
				int pm100 = IPConnection.unsignedShort(bb.getShort());

				for (PMConcentrationListener listener: listenerPMConcentration) {
					listener.pmConcentration(pm10, pm25, pm100);
				}
			}
		};

		callbacks[CALLBACK_PM_COUNT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int greater03um = IPConnection.unsignedShort(bb.getShort());
				int greater05um = IPConnection.unsignedShort(bb.getShort());
				int greater10um = IPConnection.unsignedShort(bb.getShort());
				int greater25um = IPConnection.unsignedShort(bb.getShort());
				int greater50um = IPConnection.unsignedShort(bb.getShort());
				int greater100um = IPConnection.unsignedShort(bb.getShort());

				for (PMCountListener listener: listenerPMCount) {
					listener.pmCount(greater03um, greater05um, greater10um, greater25um, greater50um, greater100um);
				}
			}
		};
	}

	/**
	 * Returns the particulate matter concentration, broken down as:
	 * 
	 * * PM\ :sub:`1.0`\ ,
	 * * PM\ :sub:`2.5`\  and
	 * * PM\ :sub:`10.0`\ .
	 * 
	 * If the sensor is disabled (see {@link BrickletParticulateMatter#setEnable(boolean)}) then the last known good
	 * values from the sensor are returned.
	 * 
	 * If you want to get the values periodically, it is recommended to use the
	 * {@link BrickletParticulateMatter.PMConcentrationListener} listener. You can set the listener configuration
	 * with {@link BrickletParticulateMatter#setPMConcentrationCallbackConfiguration(long, boolean)}.
	 */
	public PMConcentration getPMConcentration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_PM_CONCENTRATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PMConcentration obj = new PMConcentration();
		obj.pm10 = IPConnection.unsignedShort(bb.getShort());
		obj.pm25 = IPConnection.unsignedShort(bb.getShort());
		obj.pm100 = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the number of particulates in 100 ml of air, broken down by their
	 * diameter:
	 * 
	 * * greater 0.3µm,
	 * * greater 0.5µm,
	 * * greater 1.0µm,
	 * * greater 2.5µm,
	 * * greater 5.0µm and
	 * * greater 10.0µm.
	 * 
	 * If the sensor is disabled (see {@link BrickletParticulateMatter#setEnable(boolean)}) then the last known good
	 * value from the sensor is returned.
	 * 
	 * If you want to get the values periodically, it is recommended to use the
	 * {@link BrickletParticulateMatter.PMCountListener} listener. You can set the listener configuration
	 * with {@link BrickletParticulateMatter#setPMCountCallbackConfiguration(long, boolean)}.
	 */
	public PMCount getPMCount() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_PM_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PMCount obj = new PMCount();
		obj.greater03um = IPConnection.unsignedShort(bb.getShort());
		obj.greater05um = IPConnection.unsignedShort(bb.getShort());
		obj.greater10um = IPConnection.unsignedShort(bb.getShort());
		obj.greater25um = IPConnection.unsignedShort(bb.getShort());
		obj.greater50um = IPConnection.unsignedShort(bb.getShort());
		obj.greater100um = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Enables/Disables the fan and the laser diode of the sensors.
	 * 
	 * The sensor takes about 30 seconds after it is enabled to settle and produce stable
	 * values.
	 * 
	 * The laser diode has a lifetime of about 8000 hours. If you want to measure in
	 * an interval with a long idle time (e.g. hourly) you should turn the
	 * laser diode off between the measurements.
	 */
	public void setEnable(boolean enable) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_ENABLE, this);

		bb.put((byte)(enable ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the state of the sensor as set by {@link BrickletParticulateMatter#setEnable(boolean)}.
	 */
	public boolean getEnable() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ENABLE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enable = (bb.get()) != 0;

		return enable;
	}

	/**
	 * Returns information about the sensor:
	 * 
	 * * the sensor version number,
	 * * the last error code reported by the sensor (0 means no error) and
	 * * the number of framing and checksum errors that occurred in the communication
	 *   with the sensor.
	 */
	public SensorInfo getSensorInfo() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SENSOR_INFO, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SensorInfo obj = new SensorInfo();
		obj.sensorVersion = IPConnection.unsignedByte(bb.get());
		obj.lastErrorCode = IPConnection.unsignedByte(bb.get());
		obj.framingErrorCount = IPConnection.unsignedByte(bb.get());
		obj.checksumErrorCount = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * The period is the period with which the {@link BrickletParticulateMatter.PMConcentrationListener}
	 * listener is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change within the
	 * period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 */
	public void setPMConcentrationCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_PM_CONCENTRATION_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletParticulateMatter#setPMConcentrationCallbackConfiguration(long, boolean)}.
	 */
	public PMConcentrationCallbackConfiguration getPMConcentrationCallbackConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_PM_CONCENTRATION_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PMConcentrationCallbackConfiguration obj = new PMConcentrationCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * The period is the period with which the {@link BrickletParticulateMatter.PMCountListener} listener
	 * is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change within the
	 * period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 */
	public void setPMCountCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_PM_COUNT_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletParticulateMatter#setPMCountCallbackConfiguration(long, boolean)}.
	 */
	public PMCountCallbackConfiguration getPMCountCallbackConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_PM_COUNT_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PMCountCallbackConfiguration obj = new PMCountCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletParticulateMatter#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletParticulateMatter#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletParticulateMatter#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletParticulateMatter#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a PMConcentration listener.
	 */
	public void addPMConcentrationListener(PMConcentrationListener listener) {
		listenerPMConcentration.add(listener);
	}

	/**
	 * Removes a PMConcentration listener.
	 */
	public void removePMConcentrationListener(PMConcentrationListener listener) {
		listenerPMConcentration.remove(listener);
	}

	/**
	 * Adds a PMCount listener.
	 */
	public void addPMCountListener(PMCountListener listener) {
		listenerPMCount.add(listener);
	}

	/**
	 * Removes a PMCount listener.
	 */
	public void removePMCountListener(PMCountListener listener) {
		listenerPMCount.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletParticulateMatter.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletParticulateMatter.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletParticulateMatterConfig cfg = (BrickletParticulateMatterConfig) config.as(BrickletParticulateMatterConfig.class);
        this.addPMConcentrationListener((pm10, pm25, pm100) -> {if(true) {updateStateFn.accept("BrickletParticulateMatterPM10Concentration", transformBrickletParticulateMatterPM10ConcentrationCallback0(pm10, pm25, pm100, cfg));}});
		this.addPMConcentrationListener((pm10, pm25, pm100) -> {if(true) {updateStateFn.accept("BrickletParticulateMatterPM25Concentration", transformBrickletParticulateMatterPM25ConcentrationCallback0(pm10, pm25, pm100, cfg));}});
		this.addPMConcentrationListener((pm10, pm25, pm100) -> {if(true) {updateStateFn.accept("BrickletParticulateMatterPM100Concentration", transformBrickletParticulateMatterPM100ConcentrationCallback0(pm10, pm25, pm100, cfg));}});
		this.addPMCountListener((greater03um, greater05um, greater10um, greater25um, greater50um, greater100um) -> {if(true) {updateStateFn.accept("BrickletParticulateMatterPartCount3", transformBrickletParticulateMatterPartCount3Callback0(greater03um, greater05um, greater10um, greater25um, greater50um, greater100um, cfg));}});
		this.addPMCountListener((greater03um, greater05um, greater10um, greater25um, greater50um, greater100um) -> {if(true) {updateStateFn.accept("BrickletParticulateMatterPartCount5", transformBrickletParticulateMatterPartCount5Callback0(greater03um, greater05um, greater10um, greater25um, greater50um, greater100um, cfg));}});
		this.addPMCountListener((greater03um, greater05um, greater10um, greater25um, greater50um, greater100um) -> {if(true) {updateStateFn.accept("BrickletParticulateMatterPartCount10", transformBrickletParticulateMatterPartCount10Callback0(greater03um, greater05um, greater10um, greater25um, greater50um, greater100um, cfg));}});
		this.addPMCountListener((greater03um, greater05um, greater10um, greater25um, greater50um, greater100um) -> {if(true) {updateStateFn.accept("BrickletParticulateMatterPartCount25", transformBrickletParticulateMatterPartCount25Callback0(greater03um, greater05um, greater10um, greater25um, greater50um, greater100um, cfg));}});
		this.addPMCountListener((greater03um, greater05um, greater10um, greater25um, greater50um, greater100um) -> {if(true) {updateStateFn.accept("BrickletParticulateMatterPartCount50", transformBrickletParticulateMatterPartCount50Callback0(greater03um, greater05um, greater10um, greater25um, greater50um, greater100um, cfg));}});
		this.addPMCountListener((greater03um, greater05um, greater10um, greater25um, greater50um, greater100um) -> {if(true) {updateStateFn.accept("BrickletParticulateMatterPartCount100", transformBrickletParticulateMatterPartCount100Callback0(greater03um, greater05um, greater10um, greater25um, greater50um, greater100um, cfg));}});
        this.setPMCountCallbackConfiguration(cfg.pmCountUpdateInterval, true);
		        this.setPMConcentrationCallbackConfiguration(cfg.pmConcentrationUpdateInterval, true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletParticulateMatterPM10ConcentrationConfig channelCfg = getChannelConfigFn.apply("BrickletParticulateMatterPM10Concentration").as(BrickletParticulateMatterPM10ConcentrationConfig.class);
		
		}
		{
		BrickletParticulateMatterPM25ConcentrationConfig channelCfg = getChannelConfigFn.apply("BrickletParticulateMatterPM25Concentration").as(BrickletParticulateMatterPM25ConcentrationConfig.class);
		
		}
		{
		BrickletParticulateMatterPM100ConcentrationConfig channelCfg = getChannelConfigFn.apply("BrickletParticulateMatterPM100Concentration").as(BrickletParticulateMatterPM100ConcentrationConfig.class);
		
		}
		{
		BrickletParticulateMatterPartCount3Config channelCfg = getChannelConfigFn.apply("BrickletParticulateMatterPartCount3").as(BrickletParticulateMatterPartCount3Config.class);
		
		}
		{
		BrickletParticulateMatterPartCount5Config channelCfg = getChannelConfigFn.apply("BrickletParticulateMatterPartCount5").as(BrickletParticulateMatterPartCount5Config.class);
		
		}
		{
		BrickletParticulateMatterPartCount10Config channelCfg = getChannelConfigFn.apply("BrickletParticulateMatterPartCount10").as(BrickletParticulateMatterPartCount10Config.class);
		
		}
		{
		BrickletParticulateMatterPartCount25Config channelCfg = getChannelConfigFn.apply("BrickletParticulateMatterPartCount25").as(BrickletParticulateMatterPartCount25Config.class);
		
		}
		{
		BrickletParticulateMatterPartCount50Config channelCfg = getChannelConfigFn.apply("BrickletParticulateMatterPartCount50").as(BrickletParticulateMatterPartCount50Config.class);
		
		}
		{
		BrickletParticulateMatterPartCount100Config channelCfg = getChannelConfigFn.apply("BrickletParticulateMatterPartCount100").as(BrickletParticulateMatterPartCount100Config.class);
		
		}
		{
		BrickletParticulateMatterSensorEnabledConfig channelCfg = getChannelConfigFn.apply("BrickletParticulateMatterSensorEnabled").as(BrickletParticulateMatterSensorEnabledConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletParticulateMatterConfig cfg = (BrickletParticulateMatterConfig) config.as(BrickletParticulateMatterConfig.class);
        this.listenerPMConcentration.clear();
		this.listenerPMConcentration.clear();
		this.listenerPMConcentration.clear();
		this.listenerPMCount.clear();
		this.listenerPMCount.clear();
		this.listenerPMCount.clear();
		this.listenerPMCount.clear();
		this.listenerPMCount.clear();
		this.listenerPMCount.clear();
        
		
		
		
		
		
		
		
		
		this.setPMCountCallbackConfiguration(0, true);
		        this.setPMConcentrationCallbackConfiguration(0, true);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletParticulateMatterConfig cfg = (BrickletParticulateMatterConfig) config.as(BrickletParticulateMatterConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletParticulateMatterPM10Concentration");
		result.add("BrickletParticulateMatterPM25Concentration");
		result.add("BrickletParticulateMatterPM100Concentration");
		result.add("BrickletParticulateMatterPartCount3");
		result.add("BrickletParticulateMatterPartCount5");
		result.add("BrickletParticulateMatterPartCount10");
		result.add("BrickletParticulateMatterPartCount25");
		result.add("BrickletParticulateMatterPartCount50");
		result.add("BrickletParticulateMatterPartCount100");
		result.add("BrickletParticulateMatterSensorEnabled");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletParticulateMatterPM10Concentration":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPM10Concentration"), "PM 1.0 Concentration", "Number:Density").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletParticulateMatterPM10Concentration")).withDescription("The particulate matter 1.0 concentration. If the sensor is disabled then the last known good values from the sensor are returned.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletParticulateMatterPM25Concentration":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPM25Concentration"), "PM 2.5 Concentration", "Number:Density").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletParticulateMatterPM25Concentration")).withDescription("The particulate matter 2.5 concentration. If the sensor is disabled then the last known good values from the sensor are returned.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletParticulateMatterPM100Concentration":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPM100Concentration"), "PM 10.0 Concentration", "Number:Density").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletParticulateMatterPM100Concentration")).withDescription("The particulate matter 10.0 concentration. If the sensor is disabled then the last known good values from the sensor are returned.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletParticulateMatterPartCount3":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount3"), "Particulates Greater 0.3µm", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletParticulateMatterPartCount3")).withDescription("The number of particulates greater than 0.3µm in 100 ml of air. If the sensor is disabled then the last known good values from the sensor are returned.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletParticulateMatterPartCount5":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount5"), "Particulates Greater 0.5µm", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletParticulateMatterPartCount5")).withDescription("The number of particulates greater than 0.5µm in 100 ml of air. If the sensor is disabled then the last known good values from the sensor are returned.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletParticulateMatterPartCount10":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount10"), "Particulates Greater 1.0µm", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletParticulateMatterPartCount10")).withDescription("The number of particulates greater than 1.0µm in 100 ml of air. If the sensor is disabled then the last known good values from the sensor are returned.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletParticulateMatterPartCount25":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount25"), "Particulates Greater 2.5µm", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletParticulateMatterPartCount25")).withDescription("The number of particulates greater than 2.5µm in 100 ml of air. If the sensor is disabled then the last known good values from the sensor are returned.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletParticulateMatterPartCount50":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount50"), "Particulates Greater 5.0µm", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletParticulateMatterPartCount50")).withDescription("The number of particulates greater than 5.0µm in 100 ml of air. If the sensor is disabled then the last known good values from the sensor are returned.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletParticulateMatterPartCount100":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount100"), "Particulates Greater 10.0µm", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletParticulateMatterPartCount100")).withDescription("The number of particulates greater than 10.0µm in 100 ml of air. If the sensor is disabled then the last known good values from the sensor are returned.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletParticulateMatterSensorEnabled":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterSensorEnabled"), "NOT USED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletParticulateMatterSensorEnabled")).withDescription("NOT USED").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Particulate Matter Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures Particulate Matter concentration (PM1.0, PM2.5 and PM10)").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletParticulateMatterPM10Concentration", new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPM10Concentration")).withLabel("PM 1.0 Concentration").build(), new ChannelDefinitionBuilder("BrickletParticulateMatterPM25Concentration", new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPM25Concentration")).withLabel("PM 2.5 Concentration").build(), new ChannelDefinitionBuilder("BrickletParticulateMatterPM100Concentration", new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPM100Concentration")).withLabel("PM 10.0 Concentration").build(), new ChannelDefinitionBuilder("BrickletParticulateMatterPartCount3", new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount3")).withLabel("Particulates Greater 0.3µm").build(), new ChannelDefinitionBuilder("BrickletParticulateMatterPartCount5", new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount5")).withLabel("Particulates Greater 0.5µm").build(), new ChannelDefinitionBuilder("BrickletParticulateMatterPartCount10", new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount10")).withLabel("Particulates Greater 1.0µm").build(), new ChannelDefinitionBuilder("BrickletParticulateMatterPartCount25", new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount25")).withLabel("Particulates Greater 2.5µm").build(), new ChannelDefinitionBuilder("BrickletParticulateMatterPartCount50", new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount50")).withLabel("Particulates Greater 5.0µm").build(), new ChannelDefinitionBuilder("BrickletParticulateMatterPartCount100", new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterPartCount100")).withLabel("Particulates Greater 10.0µm").build(), new ChannelDefinitionBuilder("BrickletParticulateMatterSensorEnabled", new ChannelTypeUID("tinkerforge", "BrickletParticulateMatterSensorEnabled")).withLabel("Sensor Enabled").withDescription("Enables/Disables the fan and the laser diode of the sensors.<br/><br/>The sensor takes about 30 seconds after it is enabled to settle and produce stable values.<br/><br/>The laser diode has a lifetime of about 8000 hours. If you want to measure in an interval with a long idle time (e.g. hourly) you should turn the laser diode off between the measurements.").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletparticulatematter":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("pmConcentrationUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for all PM concentration data in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("PM Concentration Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("pmCountUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for all PM count data in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("PM Count Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletParticulateMatterPM10Concentration":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletParticulateMatterPM25Concentration":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletParticulateMatterPM100Concentration":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletParticulateMatterPartCount3":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletParticulateMatterPartCount5":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletParticulateMatterPartCount10":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletParticulateMatterPartCount25":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletParticulateMatterPartCount50":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletParticulateMatterPartCount100":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletParticulateMatterSensorEnabled":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletParticulateMatterConfig cfg = (BrickletParticulateMatterConfig) config.as(BrickletParticulateMatterConfig.class);
        switch(channel) {
            case "BrickletParticulateMatterPM10Concentration": {
                   BrickletParticulateMatterPM10ConcentrationConfig channelCfg = channelConfig.as(BrickletParticulateMatterPM10ConcentrationConfig.class);
                   {
            PMConcentration value = this.getPMConcentration();
            if(true)
                updateStateFn.accept(channel, transformBrickletParticulateMatterPM10ConcentrationGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletParticulateMatterPM25Concentration": {
                   BrickletParticulateMatterPM25ConcentrationConfig channelCfg = channelConfig.as(BrickletParticulateMatterPM25ConcentrationConfig.class);
                   {
            PMConcentration value = this.getPMConcentration();
            if(true)
                updateStateFn.accept(channel, transformBrickletParticulateMatterPM25ConcentrationGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletParticulateMatterPM100Concentration": {
                   BrickletParticulateMatterPM100ConcentrationConfig channelCfg = channelConfig.as(BrickletParticulateMatterPM100ConcentrationConfig.class);
                   {
            PMConcentration value = this.getPMConcentration();
            if(true)
                updateStateFn.accept(channel, transformBrickletParticulateMatterPM100ConcentrationGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletParticulateMatterPartCount3": {
                   BrickletParticulateMatterPartCount3Config channelCfg = channelConfig.as(BrickletParticulateMatterPartCount3Config.class);
                   {
            PMCount value = this.getPMCount();
            if(true)
                updateStateFn.accept(channel, transformBrickletParticulateMatterPartCount3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletParticulateMatterPartCount5": {
                   BrickletParticulateMatterPartCount5Config channelCfg = channelConfig.as(BrickletParticulateMatterPartCount5Config.class);
                   {
            PMCount value = this.getPMCount();
            if(true)
                updateStateFn.accept(channel, transformBrickletParticulateMatterPartCount5Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletParticulateMatterPartCount10": {
                   BrickletParticulateMatterPartCount10Config channelCfg = channelConfig.as(BrickletParticulateMatterPartCount10Config.class);
                   {
            PMCount value = this.getPMCount();
            if(true)
                updateStateFn.accept(channel, transformBrickletParticulateMatterPartCount10Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletParticulateMatterPartCount25": {
                   BrickletParticulateMatterPartCount25Config channelCfg = channelConfig.as(BrickletParticulateMatterPartCount25Config.class);
                   {
            PMCount value = this.getPMCount();
            if(true)
                updateStateFn.accept(channel, transformBrickletParticulateMatterPartCount25Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletParticulateMatterPartCount50": {
                   BrickletParticulateMatterPartCount50Config channelCfg = channelConfig.as(BrickletParticulateMatterPartCount50Config.class);
                   {
            PMCount value = this.getPMCount();
            if(true)
                updateStateFn.accept(channel, transformBrickletParticulateMatterPartCount50Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletParticulateMatterPartCount100": {
                   BrickletParticulateMatterPartCount100Config channelCfg = channelConfig.as(BrickletParticulateMatterPartCount100Config.class);
                   {
            PMCount value = this.getPMCount();
            if(true)
                updateStateFn.accept(channel, transformBrickletParticulateMatterPartCount100Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletParticulateMatterSensorEnabled": {
                   BrickletParticulateMatterSensorEnabledConfig channelCfg = channelConfig.as(BrickletParticulateMatterSensorEnabledConfig.class);
                   {
            boolean value = this.getEnable();
            if(true)
                updateStateFn.accept(channel, transformBrickletParticulateMatterSensorEnabledGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletParticulateMatterConfig cfg = (BrickletParticulateMatterConfig) config.as(BrickletParticulateMatterConfig.class);
        switch(channel) {
            case "BrickletParticulateMatterSensorEnabled":
                if (command instanceof OnOffType) {
                    BrickletParticulateMatterSensorEnabledConfig channelCfg = channelConfig.as(BrickletParticulateMatterSensorEnabledConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setEnable(cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPM10ConcentrationCallback0(int pm10, int pm25, int pm100, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(pm10, SmartHomeUnits.MICROGRAM_PER_CUBICMETRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPM25ConcentrationCallback0(int pm10, int pm25, int pm100, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(pm25, SmartHomeUnits.MICROGRAM_PER_CUBICMETRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPM100ConcentrationCallback0(int pm10, int pm25, int pm100, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(pm100, SmartHomeUnits.MICROGRAM_PER_CUBICMETRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount3Callback0(int greater03um, int greater05um, int greater10um, int greater25um, int greater50um, int greater100um, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(greater03um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount5Callback0(int greater03um, int greater05um, int greater10um, int greater25um, int greater50um, int greater100um, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(greater05um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount10Callback0(int greater03um, int greater05um, int greater10um, int greater25um, int greater50um, int greater100um, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(greater10um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount25Callback0(int greater03um, int greater05um, int greater10um, int greater25um, int greater50um, int greater100um, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(greater25um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount50Callback0(int greater03um, int greater05um, int greater10um, int greater25um, int greater50um, int greater100um, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(greater50um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount100Callback0(int greater03um, int greater05um, int greater10um, int greater25um, int greater50um, int greater100um, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(greater100um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPM10ConcentrationGetter0(PMConcentration value, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(value.pm10, SmartHomeUnits.MICROGRAM_PER_CUBICMETRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPM25ConcentrationGetter0(PMConcentration value, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(value.pm25, SmartHomeUnits.MICROGRAM_PER_CUBICMETRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPM100ConcentrationGetter0(PMConcentration value, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(value.pm100, SmartHomeUnits.MICROGRAM_PER_CUBICMETRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount3Getter0(PMCount value, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(value.greater03um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount5Getter0(PMCount value, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(value.greater05um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount10Getter0(PMCount value, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(value.greater10um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount25Getter0(PMCount value, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(value.greater25um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount50Getter0(PMCount value, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(value.greater50um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterPartCount100Getter0(PMCount value, BrickletParticulateMatterConfig cfg) {
        return new QuantityType<>(value.greater100um, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletParticulateMatterSensorEnabledGetter0(boolean value, BrickletParticulateMatterConfig cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
}
